Attribute VB_Name = "Module1"
'===========================================================================
'   FredJust
'   fred.just@ free.fr
'   Active Visual Basic
'   http://www.fredjust.com
'===========================================================================


Option Explicit

'RENVOIE LE HWND DE LA FENETRE ACTIVE
Public Declare Function GetForegroundWindow Lib "user32" () As Long

'RENVOIE LA FENETRE DE L APPLICATION
Public Declare Function GetActiveWindow Lib "user32" () As Long

'PERMET DE MODIFIER LA POSITION D UNE FENETRE
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long

'PERMET D ACCEDER AU CAPTION D UNE FENETRE
Public Declare Function GetWindowText Lib "user32" Alias "GetWindowTextA" (ByVal hwnd As Long, ByVal lpString As String, ByVal cch As Long) As Long

'LECTURE INI
Private Declare Function GetPrivateProfileString Lib "Kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As Any, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long


'REND UNE FENETRE ACTIVE
'Public Declare Function SetWinFocus Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long

'OUVRE UN FICHIER AVEC LE PROGRAMME ASSOCIE
Public Declare Function ShellExecuteForExplore Lib "shell32.dll" Alias "ShellExecuteA" _
        (ByVal hwnd As Long, _
        ByVal lpOperation As String, _
        ByVal lpFile As Any, _
        lpParameters As Any, _
        lpDirectory As Any, _
        ByVal nShowCmd As Long) As Long


Const IDANI_OPEN = &H1
Const IDANI_CLOSE = &H2
Const IDANI_CAPTION = &H3
Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

'RENVOIE UNE VARIABLE DE TYPE RECT
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
'DESSINE UNE ANIMATION D OUVERTURE
Private Declare Function DrawAnimatedRects Lib "user32" (ByVal hwnd As Long, ByVal idAni As Long, lprcFrom As RECT, lprcTo As RECT) As Long
'RENVOIE EN RECTANGLE CORRESPONDANT A UNE FENETRE
Private Declare Function GetWindowRect Lib "user32" (ByVal hwnd As Long, lpRect As RECT) As Long

'HWND DE LA FENTRE ACTIVE
Public ActiveWindow As Long
'HWND DE LA FENETRE DE L APPLICATION
Public MeWindow As Long

'COLLECTION CONTENANT LES FENETRES QUE L ON A PLACE ON TOP
Public WinModif As Collection

'===============================================================================
'   DEPLACE UNE FENETRE VERS LE PREMIER PLAN
'===============================================================================
Public Sub ShowOn(ByVal Winhwnd As Long, ByVal TopMost As Boolean)
On Error Resume Next
    If TopMost Then
        Call SetWindowPos(Winhwnd, -1, 10, 10, 800, 600, 83)
    Else
        Call SetWindowPos(Winhwnd, -2, 0, 0, 0, 0, 83)
    End If
End Sub

'===========================================================================
'
'===========================================================================
Public Sub redimensionne(ByVal Winhwnd As Long, ByVal section As String)
Dim SizeX As Long
Dim SizeY As Long
Dim le As Long
Dim tp As Long
On Error GoTo gestion_erreur
    SizeX = CLng(ReadIniFile(App.Path & "\size.ini", section, "X", ""))
    SizeY = CLng(ReadIniFile(App.Path & "\size.ini", section, "Y", ""))
    le = ((Screen.Width / Screen.TwipsPerPixelX) - SizeX) / 2
    tp = ((Screen.Height / Screen.TwipsPerPixelY) - SizeY) / 2
    Call SetWindowPos(Winhwnd, 0, le, tp, SizeX, SizeY, 0)
    
    Exit Sub
gestion_erreur:
    Beep
End Sub

'===========================================================================
'   RENVOI LE CAPTION D UNE FENETRE
'===========================================================================
Public Function GetFormCaption(ByVal Winhwnd As Long) As String
    'KPD-Team 1998
    'URL: http://www.allapi.net/
    'E-Mail: KPDTeam@Allapi.net
    Dim MyStr As String
    'Create a buffer
    MyStr = String(100, Chr$(0))
    'Get the windowtext
    GetWindowText Winhwnd, MyStr, 100
    'strip the rest of buffer
    GetFormCaption = Left$(MyStr, InStr(MyStr, Chr$(0)) - 1)
End Function


'===========================================================================
'   CREE UNE ANIMATION D OUVERTURE SUR UNE FENETRE
'===========================================================================
Public Sub AnimShow(ByVal Winhwnd As Long)
    Dim rSource As RECT, rDest As RECT
    
    GetWindowRect Winhwnd, rSource
    
    With rSource
        SetRect rSource, (.Left + .Right) \ 2, (.Top + .Bottom) \ 2, _
         (.Left + .Right) \ 2, (.Top + .Bottom) \ 2
    End With
    
    GetWindowRect Winhwnd, rDest
    DrawAnimatedRects Winhwnd, IDANI_OPEN Or IDANI_CAPTION, rSource, rDest
End Sub

'===========================================================================
'   DESSINE UNE ANIMATION DE FERMETURE SUR UNE FENETRE
'===========================================================================
Public Sub AnimHide(ByVal Winhwnd As Long)
    Dim rSource As RECT, rDest As RECT
    
    GetWindowRect Winhwnd, rDest
    
    With rDest
        SetRect rDest, (.Left + .Right) \ 2, (.Top + .Bottom) \ 2, _
         (.Left + .Right) \ 2, (.Top + .Bottom) \ 2
    End With
    
    GetWindowRect Winhwnd, rSource
    'animate
    DrawAnimatedRects Winhwnd, IDANI_CLOSE Or IDANI_CAPTION, rSource, rDest
End Sub
